#############################################################
# SSI_Center.pl		for YaBB 1 Gold - SP1			#
#############################################################
# Mod Name:				SSI_Center 1.0b3 			#
# File written by:		Ironwing				#
# Support, News, Updates at:	http://boardmod.yabbforum.com	#
#############################################################
$SSI_Center_ver = "SSI Center v1.0 beta 3";

# This routine creates the form for selecting SSI files to edit and creating new SSI files 
sub SSI_Center_Main {

	&is_admin;

	my $helpfile2 = $helpfile;
	$helpfile2 =~ m/(.+)(\/.+$)/;
	my $ssichelpfile = $1 . qq~/SSI_Center_Help.html~;

	my $mainfile = qq~$vardir/ssi_center.txt~;
	if ( -e $mainfile) {
		fopen(FILE, $mainfile);
		@ssicindex = <FILE>;
		fclose(FILE);
		$iii = 0;
		foreach $ssicline (@ssicindex) {
			chomp $ssicline;
			($ssicname[$iii], $ssicformat[$iii], $ssictagflag[$iii]) = split(/\|/,$ssicline);
			chomp $ssictagflag[$iii];
			if( $ssictagflag[$iii] == 1) {
				$ssictagflagcheck[$iii] = ' checked';
			}
			$iii++;
		}
	}

	$yymain .= qq~
<form action="$cgi;action=ssicmain2" method="POST">
 <table border=0 width="80%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
  <tr>
   <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="5" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/grin.gif">&nbsp$ssictxt{'06'}<br><center><a href="$ssichelpfile" target="_blank">$ssictxt{'22'}</a></center></font></b></td>
  </tr>
  <tr>
   <td class="catbg" bgcolor="$color{'catbg'}" width="29%" height=22><b><font size=2>$ssictxt{'02'}</font></b></td>
   <td class="catbg" bgcolor="$color{'catbg'}" width="25%"><b><font size=2>$ssictxt{'03'}</font></b></td>
   <td class="catbg" bgcolor="$color{'catbg'}" width="30%"><b><font size=2>$ssictxt{'04'}</font></b></td>
   <td class="catbg" bgcolor="$color{'catbg'}" width="10%"><b><font size=2>$ssictxt{'23'}</font></b></td>
   <td class="catbg" bgcolor="$color{'catbg'}" width="6%" align=center><b><font size=2>$ssictxt{'05'}</font></b></td>
  </tr>
~;

	$i=0;
	while($ssicname[$i]) {
		$yymain .= qq~
  <tr>
   <td class='windowbg' bgcolor=$color{'windowbg'} width='29%' align=center>$ssicname[$i]<input type="hidden" name="ssicname[$i]" value="$ssicname[$i]"></td>
   <td class='windowbg' bgcolor=$color{'windowbg'} width='25%' align=center>$ssicformat[$i]<input type="hidden" name="ssicformat[$i]" value="$ssicformat[$i]"></td>
   <td class='windowbg' bgcolor=$color{'windowbg'} width='30%' align=center><a href="$scripturl?action=ssicformhtml&ssicname=$ssicname[$i]&ssicformat=$ssicformat[$i]">$ssictxt{'08'}</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="$scripturl?action=ssicformyabbc&ssicname=$ssicname[$i]&ssicformat=$ssicformat[$i]">$ssictxt{'07'}</a></td>
   <td class='windowbg' bgcolor=$color{'windowbg'} width='10%' align=center><input type=checkbox name=ssictagflag[$i] value="1" $ssictagflagcheck[$i]></td>
   <td class='windowbg' bgcolor=$color{'windowbg'} width='6%' align=center><input type=checkbox name=delbox[$i] value=1></td>
  </tr>~;
		$i++;
	}
	$yymain .= qq~
  <tr>
   <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="5" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/grin.gif">&nbsp$ssictxt{'09'}</font></b></td>
  </tr>
~;
$inew=0;
while($inew < 5) {
	$yymain .= qq~
  <tr>
   <td class='windowbg' bgcolor=$color{'windowbg'} width='100%' align=left colspan=5 ><input type="hidden" name="ssicformat[$i]" value="$ssictxt{'08'}"><input type="text" name="ssicname[$i]"></td>
  </tr>~;
$i++;
$inew++;
if ($inew == 5) {
	$yymain .= qq~
  <tr>
   <td class="catbg" bgcolor="$color{'catbg'}" align="center" colspan="5"><input type=submit value="$ssictxt{'10'}"><input type=reset value="$ssictxt{'11'}"><br>$SSI_Center_ver</td>
  </tr>
 </table>
</form>
~;
}
}
	$yytitle = "$ssictxt{'01'}";
	&template;
	exit;
} # end of routine

#########################################################
# This routine writes the data from the main page form to the Variables/ssi_center.txt file.
sub SSI_Center_Main2 {
	&is_admin;

	$tempA=0;
	@verbodentags = qw( main menu ext SetCookies1 SetCookies2 news title boardname position time uname charset copyright im images template copyin SetLocation );
	while($FORM{"ssicname[$tempA]"}) {
		$ssiccheckname = $FORM{"ssicname[$tempA]"};
		foreach $ssicchecktag (@verbodentags) {
			if ( $ssicchecktag eq $ssiccheckname ) { &fatal_error("$ssictxt{'30'} $ssicchecktag $ssictxt{'31'}"); }
		}
		$tempA++;
	}


	$tempA=0;
	fopen(FILE, ">$vardir/ssi_center.txt",1);
	while($FORM{"ssicname[$tempA]"}) {
		$delcheck = $FORM{"delbox[$tempA]"};
		$var1 = $FORM{"ssicname[$tempA]"};
		$var2 = $FORM{"ssicformat[$tempA]"};
		$var3 = $FORM{"ssictagflag[$tempA]"} eq '1' ? 1 : 0;

		if ($delcheck ne "1") {
			print FILE qq~$var1|$var2|$var3\n~;
		} else {
			my $ssicfile = qq~$vardir/ssic_~ . qq~$var1~ . q~.txt~;
				if ( -e $ssicfile) {
					unlink $ssicfile;
				}
		}
		$tempA++;
	}
	fclose(FILE);

	$yySetLocation = qq~$cgi&action=ssicmain~;
	&redirectexit;

}

##########################################################
# This routine creates the form for inputting static HTML content
sub SSI_Center_Form_HTML {
	&is_admin;
	my( $ssiclines, $line );
	my $ssicname = $INFO{'ssicname'} || 'none';
	my $ssicformat = $INFO{'ssicformat'} || qq~$ssictxt{'08'}~;

	if ( $ssicformat eq $ssictxt{'20'} || $ssicformat eq $ssictxt{'24'} ) {
		$rotatingcheck = ' checked';
	}

	my $ssicfile = qq~$vardir/ssic_~ . qq~$ssicname~ . q~.txt~;
	if ( -e $ssicfile) {
		fopen(FILE, $ssicfile);
		while( $line = <FILE> ) {
#			&FromHTML($line);
			$ssiclines .= qq~$line~;
		}
		fclose(FILE);
	} else {
		$ssiclines .= '';
	}
	
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
      <img src="$imagesdir/xx.gif" alt="" border="0">
      <font size=2 class="text1" color="$color{'titletext'}"><b>$ssictxt{'12'} - $ssicname</b></font>
    </td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><br><font size="1">$ssictxt{'13'}</font><br><br>$ssictxt{'29'}<br><br></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
      <form action="$cgi;action=ssicwrite" method="POST">
        <input type="hidden" name="ssicname" value="$ssicname">
        <input type="hidden" name="ssicformat" value="$ssictxt{'08'}">
        <br>
        <textarea rows=30 cols=95 wrap=virtual name="message" style="width:98%">$ssiclines</textarea>
        <br><br>
        $ssictxt{'26'} <input type=checkbox name=rotating value="1" $rotatingcheck>
        <br><br>
        <input type=submit value="$ssictxt{'15'}$ssicname$ssictxt{'16'}">
      </form>
      </font>
    </td>
  </tr>
</table>
~;
	$yytitle = "$ssictxt{'01'}";
	&template;
	exit;
}

###########################################################
# This routine writes the content files for HTML and YaBBC static formats
sub SSI_Center_Write {
	&is_admin;
	my $ssicnamenew = $FORM{'ssicname'} || 'none';
	my $ssicformatnew = $FORM{'ssicformat'} || 'none';
	$rotating = $FORM{"rotating"} eq '1' ? 1 : 0;
	if ( $rotating == 1 ) {
		$ssicformatnew .= qq~$ssictxt{'27'}~;
	}

	my $ssicfile = qq~$vardir/ssic_~ . qq~$ssicnamenew~ . q~.txt~;
	$FORM{'message'} =~ tr/\r//d;
	$FORM{'message'} =~ s~\A\n~~;
	$FORM{'message'} =~ s~\n\Z~~;
	fopen(FILE, ">$ssicfile");
	print FILE $FORM{'message'};
	fclose(FILE);

	my $mainfile = qq~$vardir/ssi_center.txt~;
	if ( -e $mainfile) {
		fopen(FILE, $mainfile);
		@ssicindex = <FILE>;
		fclose(FILE);
		$iii = 0;
		foreach $ssicline (@ssicindex) {
			chomp $ssicline;
			($ssicname[$iii], $ssicformat[$iii], $ssictagflag[$iii]) = split(/\|/,$ssicline);
			if ( $ssicname[$iii] eq $ssicnamenew ) { $ssicformat[$iii] = $ssicformatnew; }
			$iii++;
		}
	}

	$tempA = 0;
	fopen(FILE, ">$vardir/ssi_center.txt",1);
	while($ssicname[$tempA]) {
		$var1 = $ssicname[$tempA];
		$var2 = $ssicformat[$tempA];
		$var3 = $ssictagflag[$tempA];
		print FILE "$var1|$var2|$var3\n";
		$tempA++;
	}
	fclose(FILE);

	$yySetLocation = qq~$cgi;action=ssicmain~;
	&redirectexit;
}

####################################################################
# This routine creates the form for inputting content in YABBC format
sub SSI_Center_Form_YABBC {

	&is_admin;
	my($line);
	my $message = '';
	my $ssicname = $INFO{'ssicname'} || 'none';

	my $ssicformat = $INFO{'ssicformat'} || qq~$ssictxt{'07'}~;
	if ( $ssicformat eq $ssictxt{'20'} || $ssicformat eq $ssictxt{'24'} ) {
		$rotatingcheck = ' checked';
	}

	my $ssicfile = qq~$vardir/ssic_~ . qq~$ssicname~ . q~.txt~;
	if ( -e $ssicfile) {
		fopen(FILE, $ssicfile);
		while( $line = <FILE> ) {
			&FromHTML($line);
			$message .= qq~$line~;
		}
		fclose(FILE);
	} else {
		$message .= '';
	}

	$yymain .= qq~
<form method="post" action="$scripturl?action=ssicwrite" enctype="application/x-www-form-urlencoded" name="postmodify" onSubmit="return submitproc()">
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
  <input type="hidden" name="ssicname" value="$ssicname">
  <input type="hidden" name="ssicformat" value="$ssictxt{'07'}">
  <TABLE border=2 width=90%>
    <CAPTION>$ssictxt{'14'} - $ssicname</CAPTION>
    <tr>
      <td align=center>~;
if($enable_ubbc && $showyabbcbutt) {
	$yymain .= qq~
    <table width="100%" cellpadding="3" cellspacing="0">
      <tr>
        <td width="23%"><font size=2><b>$txt{'252'}:</b></font></td>
        <td valign=middle class="newcal3">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<a href=javascript:bold()><img src='$imagesdir/bold.gif' align=bottom width=23 height=22 alt='$txt{'253'}' border=0></a>");
          document.write("<a href=javascript:italicize()><img src='$imagesdir/italicize.gif' align=bottom width=23 height=22 alt='$txt{'254'}' border='0'></a>");
          document.write("<a href=javascript:underline()><img src='$imagesdir/underline.gif' align=bottom width=23 height=22 alt='$txt{'255'}' border='0'></a>");
          document.write("<a href=javascript:strike()><img src='$imagesdir/strike.gif' align=bottom width=23 height=22 alt='$txt{'441'}' border='0'></a>");
          document.write("<a href=javascript:glow()><img src='$imagesdir/glow.gif' align=bottom width=23 height=22 alt='$txt{'442'}' border='0'></a>");
          document.write("<a href=javascript:shadow()><img src='$imagesdir/shadow.gif' align=bottom width=23 height=22 alt='$txt{'443'}' border='0'></a>");
          document.write("<a href=javascript:move()><img src='$imagesdir/move.gif' align=bottom width=23 height=22 alt='$txt{'439'}' border='0'></a>");
          document.write("<a href=javascript:pre()><img src='$imagesdir/pre.gif' align=bottom width=23 height=22 alt='$txt{'444'}' border='0'></a>");
          document.write("<a href=javascript:left()><img src='$imagesdir/left.gif' align=bottom width=23 height=22 alt='$txt{'445'}' border='0'></a>");
          document.write("<a href=javascript:center()><img src='$imagesdir/center.gif' align=bottom width=23 height=22 alt='$txt{'256'}' border='0'></a>");
          document.write("<a href=javascript:right()><img src='$imagesdir/right.gif' align=bottom width=23 height=22 alt='$txt{'446'}' border='0'></a>");
          document.write("<a href=javascript:hr()><img src='$imagesdir/hr.gif' align=bottom width=23 height=22 alt='$txt{'531'}' border='0'></a>");
          document.write("<a href=javascript:size()><img src='$imagesdir/size.gif' align=bottom width=23 height=22 alt='$txt{'532'}' border='0'></a>");
          document.write("<a href=javascript:font()><img src='$imagesdir/face.gif' align=bottom width=23 height=22 alt='$txt{'533'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        <select name="color" onChange="showcolor(this.options[this.selectedIndex].value)">
         <option value="Black" selected>$txt{'262'}</option>
         <option value="Red">$txt{'263'}</option>
         <option value="Yellow">$txt{'264'}</option>
         <option value="Pink">$txt{'265'}</option>
         <option value="Green">$txt{'266'}</option>
         <option value="Orange">$txt{'267'}</option>
         <option value="Purple">$txt{'268'}</option>
         <option value="Blue">$txt{'269'}</option>
         <option value="Beige">$txt{'270'}</option>
         <option value="Brown">$txt{'271'}</option>
         <option value="Teal">$txt{'272'}</option>
         <option value="Navy">$txt{'273'}</option>
         <option value="Maroon">$txt{'274'}</option>
         <option value="LimeGreen">$txt{'275'}</option>
        </select>
        <br>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<a href=javascript:flash()><img src='$imagesdir/flash.gif' align=bottom width=23 height=22 alt='$txt{'433'}' border='0'></a>");
          document.write("<a href=javascript:hyperlink()><img src='$imagesdir/url.gif' align=bottom width=23 height=22 alt='$txt{'257'}' border='0'></a>");
          document.write("<a href=javascript:ftp()><img src='$imagesdir/ftp.gif' align=bottom width=23 height=22 alt='$txt{'434'}' border='0'></a>");
          document.write("<a href=javascript:image()><img src='$imagesdir/img.gif' align=bottom width=23 height=22 alt='$txt{'435'}' border='0'></a>");
          document.write("<a href=javascript:emai1()><img src='$imagesdir/email2.gif' align=bottom width=23 height=22 alt='$txt{'258'}' border='0'></a>");
          document.write("<a href=javascript:table()><img src='$imagesdir/table.gif' align=bottom width=23 height=22 alt='$txt{'436'}' border='0'></a>");
          document.write("<a href=javascript:trow()><img src='$imagesdir/tr.gif' align=bottom width=23 height=22 alt='$txt{'437'}' border='0'></a>");
          document.write("<a href=javascript:tcol()><img src='$imagesdir/td.gif' align=bottom width=23 height=22 alt='$txt{'449'}' border='0'></a>");
          document.write("<a href=javascript:superscript()><img src='$imagesdir/sup.gif' align=bottom width=23 height=22 alt='$txt{'447'}' border='0'></a>");
          document.write("<a href=javascript:subscript()><img src='$imagesdir/sub.gif' align=bottom width=23 height=22 alt='$txt{'448'}' border='0'></a>");
          document.write("<a href=javascript:teletype()><img src='$imagesdir/tele.gif' align=bottom width=23 height=22 alt='$txt{'440'}' border='0'></a>");
          document.write("<a href=javascript:showcode()><img src='$imagesdir/code.gif' align=bottom width=23 height=22 alt='$txt{'259'}' border='0'></a>");
          document.write("<a href=javascript:quote()><img src='$imagesdir/quote2.gif' align=bottom width=23 height=22 alt='$txt{'260'}' border='0'></a>");
          document.write("<a href=javascript:list()><img src='$imagesdir/list.gif' align=bottom width=23 height=22 alt='$txt{'261'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
          <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
        <table width="100%" cellpadding="3" cellspacing="0">
~;
}
	$yymain .= qq~
      <tr>
        <td width="23%"><font size=2><b>$txt{'297'}:</b></font></td>
        <td valign=middle>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' align=bottom alt='$txt{'287'}' border='0'></a> ");
          document.write("<a href=javascript:wink()><img src='$imagesdir/wink.gif' align=bottom alt='$txt{'292'}' border='0'></a> ");
          document.write("<a href=javascript:cheesy()><img src='$imagesdir/cheesy.gif' align=bottom alt='$txt{'289'}' border='0'></a> ");
          document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' align=bottom alt='$txt{'293'}' border='0'></a> ");
          document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' align=bottom alt='$txt{'288'}' border='0'></a> ");
          document.write("<a href=javascript:sad()><img src='$imagesdir/sad.gif' align=bottom alt='$txt{'291'}' border='0'></a> ");
          document.write("<a href=javascript:shocked()><img src='$imagesdir/shocked.gif' align=bottom alt='$txt{'294'}' border='0'></a> ");
          document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' align=bottom alt='$txt{'295'}' border='0'></a> ");
          document.write("<a href=javascript:huh()><img src='$imagesdir/huh.gif' align=bottom alt='$txt{'296'}' border='0'></a> ");
          document.write("<a href=javascript:rolleyes()><img src='$imagesdir/rolleyes.gif' align=bottom alt='$txt{'450'}' border='0'></a> ");
          document.write("<a href=javascript:tongue()><img src='$imagesdir/tongue.gif' align=bottom alt='$txt{'451'}' border='0'></a> ");
          document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' align=bottom alt='$txt{'526'}' border='0'></a> ");
          document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' align=bottom alt='$txt{'527'}' border='0'></a> ");
          document.write("<a href=javascript:undecided()><img src='$imagesdir/undecided.gif' align=bottom alt='$txt{'528'}' border='0'></a> ");
          document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' align=bottom alt='$txt{'529'}' border='0'></a> ");
          document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' align=bottom alt='$txt{'530'}' border='0'></a> ");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
     </tr>
</table>
~;

$yymain .=qq~
        <textarea name="message" rows=12 cols=70 wrap="physical" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);">$message</textarea>
      </td>
    </tr><tr>
      <td align = "center">
        <br>
        $ssictxt{'28'} <input type=checkbox name=rotating value="1" $rotatingcheck>
        <br><br>
        <input name="newdata" type=submit value="$ssictxt{'15'}$ssicname$ssictxt{'16'}">
        <br>
      </td>
    </tr>
    <tr>
      <td><br>$ssictxt{'29'}<br></td>
    </tr>
  </table>
</form>
~;
	$yytitle = "$ssictxt{'01'}";
	&template;
	exit;
} # end routine

####################################################
# This routine generates <yabb tags>.  It is called by the template routine in the Subs.pl file.
sub SSI_Center_YaBB_Tags {
	my $mainfileY = qq~$vardir/ssi_center.txt~;
	if ( -e $mainfileY) {
		fopen(FILE, $mainfileY);
		@ssicindexY = <FILE>;
		fclose(FILE);
		$iiiY = 0;
		foreach $ssiclineY (@ssicindexY) {
			chomp $ssiclineY;
			($ssicnameY[$iiiY], $ssicformatY[$iiiY], $ssictagflagY[$iiiY]) = split(/\|/,$ssiclineY);
			if ( $ssictagflagY[$iiiY] eq '1' ) {
				$ssicfileY = qq~$vardir/ssic_~ . qq~$ssicnameY[$iiiY]~ . q~.txt~;
				if( ( $ssicformatY[$iiiY] eq $ssictxt{'20'} ) || ( $ssicformatY[$iiiY] eq $ssictxt{'24'} ) ) {
					if ( -e $ssicfileY) {
						fopen(FILE, $ssicfileY);
						srand;
						rand($.) < 1 && ($ssicmessageY = $_) while <FILE>;
						fclose(FILE);
						chomp $ssicmessageY;
					}
				} elsif ( ( $ssicformatY[$iiiY] eq $ssictxt{'07'} ) || ( $ssicformatY[$iiiY] eq $ssictxt{'08'} ) ) {
					if ( -e $ssicfileY) {
						fopen(FILE, $ssicfileY);
						@ssiccontentsY = <FILE>;
						fclose(FILE);
					}
					$ssicmessageY = '';
					for(my $i = 0; $i < @ssiccontentsY; $i++) {
						$ssicmessageY .= $ssiccontentsY[$i];
					}
					chomp $ssicmessageY;
				}
#### ssicmessageY now holds raw content
####### Don't do UBBC on yabb tags embedded in SSI statements, will be done in SSI tag routine
#				unless ( $ssic_dotemplate eq 'ssic_dotemplate' ) {
					if( ( $ssicformatY[$iiiY] eq $ssictxt{'07'} ) || ( $ssicformatY[$iiiY] eq $ssictxt{'24'} ) ) {
						$messageholder = $message;
						$message = $ssicmessageY;
						require "$sourcedir/YaBBC.pl";
						&DoUBBC;
						$ssicmessageY = $message;
						$message = $messageholder;
					}
#				}
###########
				if($ssicmessageY =~ m~<yabb news>~ && $enable_news) {
					fopen(FILE, "$vardir/news.txt");
					@newsmessages = <FILE>;
					fclose(FILE);
					srand;
					$yynews = qq~<b>$txt{'102'}:</b> $newsmessages[int rand(@newsmessages)]~;
				}
				$ssicmessageY =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
				$ssicnameY[$iiiY] = 'yy' . $ssicnameY[$iiiY];
				my $fi;
				map { $fi = lc $_; ${$_} = $ssicmessageY; } $ssicnameY[$iiiY];
			} # end tagflag true loop
			$iiiY++;
		} # end loop through main file
	} # end mainfile exists if statement
} # end routine

####################################################
# This routine processes SSI content for output to SSI statements.  Called by SubList.pl
sub SSI_Center_SSI_Tags {

	print qq~Content-type: text/html\n\n~;
	my $ssicnamecalled = $INFO{'ssicname'} || 'none';
	my $ssicfile = qq~$vardir/ssic_~ . qq~$ssicnamecalled~ . q~.txt~;

	my $mainfile = qq~$vardir/ssi_center.txt~;
	if ( -e $mainfile) {
		fopen(FILE, $mainfile);
		@ssicindex = <FILE>;
		fclose(FILE);
		$iii = 0;
		foreach $ssicline (@ssicindex) {
			chomp $ssicline;
			($ssicname[$iii], $ssicformat[$iii], $ssictagflag[$iii]) = split(/\|/,$ssicline);
			if( $ssicname[$iii] eq $ssicnamecalled ) {
				if( ( $ssicformat[$iii] eq $ssictxt{'20'} ) || ( $ssicformat[$iii] eq $ssictxt{'24'} ) ) {
					if ( -e $ssicfile) {
						fopen(FILE, $ssicfile);
						srand;
						rand($.) < 1 && ($message = $_) while <FILE>;
						fclose(FILE);
						chomp $message;
					}
				} elsif ( ( $ssicformat[$iii] eq $ssictxt{'07'} ) || ( $ssicformat[$iii] eq $ssictxt{'08'} ) ) {
					if ( -e $ssicfile) {
						fopen(FILE, $ssicfile);
						@ssiccontents = <FILE>;
						fclose(FILE);
					}
					$message = '';
					for(my $i = 0; $i < @ssiccontents; $i++) {
						$message .= $ssiccontents[$i];
					}
					chomp $message;
				}
#### message now holds raw content
#### Go to template routine to pick up standard yystuff
#### also picks up SSI tags, may slow things down but may also allow recursive tags
				$ssic_dotemplate = 'ssic_dotemplate';
				&template;
###
				if($message =~ m~<yabb news>~ && $enable_news) {
					fopen(FILE, "$vardir/news.txt");
					@newsmessages = <FILE>;
					fclose(FILE);
					srand;
					$yynews = qq~<b>$txt{'102'}:</b> $newsmessages[int rand(@newsmessages)]~;
				}

				if( ( $ssicformat[$iii] eq $ssictxt{'07'} ) || ( $ssicformat[$iii] eq $ssictxt{'24'} ) ) {
					require "$sourcedir/YaBBC.pl";
					&DoUBBC;
				}

				$message =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
				if ($message ne ''){
					print qq~$message~;
				}
				$iii++;
			} # end name found
		} # end loop through main file
	} # end mainfile exists if statement
} # end routine
1;